package gus05.entity.gus.app.action.about2;

import java.awt.*;
import java.awt.event.*;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.swing.*;



class AboutDialog extends JDialog {
    
    private JButton closeButton;
    private JLabel infoLabel;
    
    public JButton closeButton(){return closeButton;}
    public JLabel infoLabel(){return infoLabel;}
    
    
    private SimpleDateFormat yyyy = new SimpleDateFormat("yyyy");
    private String thisYear() {return yyyy.format(new Date());}

    
    
    public AboutDialog(JFrame parent, String appName, String appVersion, String appBuild, String info, Icon iconGus05)
    {
        super(parent,true);
        init(appName,appVersion,appBuild,info,iconGus05);
    }
    
    
    
    
    private void init(String appName, String appVersion, String appBuild, String info, Icon iconGus05)
    {
        setTitle("About");
        setResizable(false);

        getContentPane().setLayout(new BorderLayout());
        setSize(300, 250);
        setLocationRelativeTo(null);
        
        addWindowListener(new WindowAdapter(){
            public void windowClosing(WindowEvent e)
            {dispose();}
        });

        JPanel panel = new JPanel();
        panel.setLayout(new GridBagLayout());
        
        closeButton = new JButton("Close");
        closeButton.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e)
            {dispose();}
        });

        JLabel label_appName = new JLabel(appName);
        JLabel label_appBuild = new JLabel("version "+appVersion+" build "+appBuild);
        JLabel label_author = new JLabel("Augustin DELALE");
        JLabel label_email = new JLabel("adelale@hotmail.com");
        JLabel label_icon = new JLabel(iconGus05);
        JLabel label_framework = new JLabel("framework gus05, Copyright (c) 2007 "+thisYear()+" Augustin Delale");
        JLabel label_website = new JLabel("http://www.gus05.com");
        if(info!=null) infoLabel = new JLabel(info);
        
        label_appName.setFont(new Font("dialog", Font.BOLD, 18));
        label_appBuild.setFont(new Font("dialog", Font.BOLD, 15));
        label_author.setFont(new Font("dialog", Font.PLAIN, 12));
        label_email.setFont(new Font("dialog", Font.PLAIN, 12));
        label_framework.setFont(new Font("dialog", Font.PLAIN, 9));
        label_website.setFont(new Font("dialog", Font.PLAIN, 9));
        if(info!=null) infoLabel.setFont(new Font("dialog", Font.PLAIN, 9));

        int n=0;
        panel.add(label_appName, createConstraints(1,n++));
        panel.add(label_appBuild, createConstraints(1,n++));
        panel.add(new JLabel(" "), createConstraints(1,n++));
        panel.add(label_author, createConstraints(1,n++));
        panel.add(label_email, createConstraints(1,n++));
        panel.add(new JLabel(" "), createConstraints(1,n++));
        panel.add(label_icon, createConstraints(1,n++));
        panel.add(label_framework, createConstraints(1,n++));
        panel.add(label_website, createConstraints(1,n++));
        if(info!=null) panel.add(infoLabel, createConstraints(1,n++));
        panel.add(new JLabel(" "), createConstraints(1,n++));
        
        panel.add(closeButton, createConstraints(1,n++));

        getContentPane().add("Center", panel);
    }
    
    
    

    
    private GridBagConstraints createConstraints(int x, int y)
    {
        GridBagConstraints c = new GridBagConstraints();
        c.gridx = x;
        c.gridy = y;
        c.gridwidth = 1;
        c.gridheight = 1;
        c.anchor = GridBagConstraints.CENTER;
        c.weightx = 0.0;
        c.weighty = 0.0;
        return c;
    }
}