
package gus05.entity.gus.file.editor.prop.publickey.editor1;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileReader;
import java.security.PublicKey;
import java.util.Properties;

import javax.swing.JComponent;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.text.JTextComponent;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;
import gus05.framework.features.Graphic;


public class PublicKeyEditor1 implements Entity, Graphic, Give {

    public String getName()				{return "gus.file.editor.prop.publickey.editor1";}
    public String getCreationDate()		{return "2008.06.11";}
    
    
    public static final String KEY_ERROR = "error";
    
    
    private Service fileToPublicKey;
    private Service textAreaHolder3;
    private Service textAreaHolder3_1;
    private Service propPanel;
    private Service signedMessageChecker;
    
    private JTabbedPane tab;
    private JTextArea area_export;
    private JTextComponent area_check;
    
    
    private File file;
    private PublicKey publicKey;
    private String errorMessage;
    
    
    
    
    public PublicKeyEditor1() throws Exception
    {
    	fileToPublicKey = Outside.service(this,"gus.security.asymkeys.filetopublickey");
    	textAreaHolder3 = Outside.service(this,"gus.graphic.textcomp.buildgui.panel3");
    	textAreaHolder3_1 = Outside.service(this,"gus.graphic.textcomp.buildgui.panel3_1");
    	propPanel = Outside.service(this,"gus.security.asymkeys.publickey.proppanel1");
    	signedMessageChecker = Outside.service(this,"gus.security.asymkeys.signedmessage.checker1");
    	
        area_export = new JTextArea();
        area_export.setEditable(false);
        area_export.setLineWrap(true);
        
        area_check = (JTextComponent) signedMessageChecker.gui();
        
        JComponent comp1 = (JComponent) textAreaHolder3.transform(area_export);
        JComponent comp2 = (JComponent) textAreaHolder3_1.transform(area_check);
        
        tab = new JTabbedPane();
        tab.addTab("properties",propPanel.gui());
        tab.addTab("check message",comp2);
        tab.addTab("export key",comp1);
    }
    
    
    
    
    
    
    
    
    
    public JComponent gui()
    {return tab;}
    
    
    
    
    
    
    
    
    public void give(Object obj) throws Exception
    {
        file = (File)obj;
        publicKey = buildPublicKey();
        
        
        String text = text();
        Properties prop = prop();
        String owner = prop.getProperty(SECURITY.PUBLICKEY_OWNER);
        
        if(errorMessage!=null)
        	prop.setProperty(KEY_ERROR,errorMessage);
        
        propPanel.give(prop);
        signedMessageChecker.give(new Object[]{publicKey,owner});
        
        area_export.setText(text);
        area_export.moveCaretPosition(0);
    }
    
    
    
    
    
    
    private PublicKey buildPublicKey()
    {
    	errorMessage = null;
    	try{return (PublicKey) fileToPublicKey.transform(file);}
    	catch(Exception e)
    	{
    		Outside.err(this,"buildPublicKey()",e);
    		errorMessage = toString(e);
    		return null;
    	}
    }

    
    
    public static String toString(Exception e)
    {
        if(e.toString().startsWith("java.lang.Exception")) return e.getMessage();
        else return e.toString();
    }
    
    
    
    
    
    
    
    
    
    
    
    
    private String text() throws Exception
    {
        if(file==null)return "";
        FileReader fr = new FileReader(file);	
        char[] a= new char[(int)file.length()];
        fr.read(a,0,(int)file.length());
        fr.close();
        return new String(a); 
    }
    
    
    private Properties prop() throws Exception
    {
    	Properties prop = new Properties();
    	FileInputStream fis = new FileInputStream(file);
    	prop.load(fis);
    	fis.close();
    	return prop;
    }
    
}
