/*
 * Framework gus04
 * 
 * Copyright (C) 2005 (Augustin Delale)
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes
 * de la Licence Publique Gnrale GNU publie par la Free Software Foundation (version 2
 * ou bien toute autre version ultrieure choisie par vous).
 * 
 * Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, 
 * ni explicite ni implicite, y compris les garanties de commercialisation ou d'adaptation
 * dans un but spcifique. Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.
 * 
 * Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ;
 * si ce n'est pas le cas, crivez  la Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, tats-Unis. 
 */
package gus05.entity.gus.graphic.dnd;

/**
 *
 * @author  gus
 */

import gus05.framework.features.Give;
import gus05.framework.features.Provide;

import java.awt.event.*;
import javax.swing.*;
import java.awt.datatransfer.*;




class TransferHandler0 extends TransferHandler implements MouseListener {
    
    private Give give;
    private Provide provide;
    private DataFlavor flavor;
    
    public TransferHandler0(Give give, Provide provide, JComponent source, DataFlavor flavor)
    {
        super();
        this.give = give;
        this.provide = provide;
        this.flavor = flavor;
        
        source.setTransferHandler(this);
        source.addMouseListener(this);
    }
    
    
    
    protected Transferable createTransferable(JComponent c)
    {
        try
        {
            Object data = provide.provide();
            return new ObjectTransferable(data,flavor);
        }
        catch (Exception e) {} 
        return null; 
    }
     
    
    
    public int getSourceActions(JComponent c)
    {return COPY;}
    
    
    public boolean importData(JComponent c, Transferable t)
    {
        try
        {
            if(give==null)return false;
            Object data = t.getTransferData(flavor);
            if(data instanceof Provide) data = ((Provide)data).provide();
            give.give(data);
            return true;
        }
        catch (Exception e) {} 
        return false;
    }
    
    
    public boolean canImport(JComponent c, DataFlavor[] flavors)
    {return give!=null;}
    
    
    
    
    public void mousePressed(MouseEvent e)
    {
        JComponent source = (JComponent)e.getSource();
        exportAsDrag(source,e,COPY);
    }
    
    public void mouseClicked(MouseEvent e){}
    public void mouseReleased(MouseEvent e){}
    public void mouseEntered(MouseEvent e){}
    public void mouseExited(MouseEvent e){}
}
