package gus05.entity.gus.graphic.textcomp.buildgui.panel4;


import java.awt.BorderLayout;
import java.util.List;

import javax.swing.Action;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JToolBar;
import javax.swing.text.JTextComponent;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Transform;



public class TextCompPanel4 implements Entity, Transform {


    public String getName()				{return "gus.graphic.textcomp.buildgui.panel4";}
    public String getCreationDate()		{return "2008.07.01";}


    private Service copyAll;
    private Service undo;
    
    

    public TextCompPanel4() throws Exception
    {
        copyAll = Outside.service(this,"gus.graphic.textcomp.action.copyall");
        undo = Outside.service(this,"gus.graphic.textcomp.action.z.undo");
    }



    public Object transform(Object obj) throws Exception
    {
        JTextComponent comp = (JTextComponent) obj;
        
        Action copyAllAction = (Action) copyAll.transform(comp);
        List undoActions = (List) undo.transform(comp);
        
        Action undoAction = (Action) undoActions.get(0);
        Action redoAction = (Action) undoActions.get(1);
        
        JToolBar toolbar = new JToolBar();
        toolbar.setFloatable(false);
        toolbar.add(copyAllAction);
        toolbar.add(undoAction);
        toolbar.add(redoAction);
        
        JPanel panel = new JPanel(new BorderLayout());
        panel.add(new JScrollPane(comp),BorderLayout.CENTER);
        panel.add(toolbar,BorderLayout.SOUTH);
       
        return panel;
    }

}

