package gus05.entity.gus.security.asymkeys.generator;



import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;
import gus05.framework.features.Register;



public class Generator implements Entity, Give, Register {

    
    public String getName() {return "gus.security.asymkeys.generator";}
    public String getCreationDate() {return "2008.06.11";}
    
    
    
    private Service generateKeys;
    
    private File storeDir;
    
    
    
    
    public Generator() throws Exception
    {
    	generateKeys = Outside.service(this,"gus.security.asymkeys.generatekeys");
    }

    
    
    public void register(String key, Object obj) throws Exception
    {
		if(key.equals("storeDir")) {storeDir = (File)obj;return;}
		throw new Exception("Unknown key: "+key);
	}
    
    
    
    
    
    public void give(Object obj) throws Exception
	{
    	if(storeDir==null)
    		throw new Exception("store dir has not been initialized yet");
    	
    	String owner = (String) obj;
    	Properties[] props = (Properties[]) generateKeys.transform(owner);
    	
    	File file_publicKey = new File(storeDir,owner+"."+SECURITY.PUBLICKEY_FILEEXTENSION);
    	File file_privateKey = new File(storeDir,owner+"."+SECURITY.PRIVATEKEY_FILEEXTENSION);
    	
    	store(file_publicKey, props[0], "public key specifications for "+owner);
    	store(file_privateKey, props[1], "private key specifications for "+owner);
    	
    	file_publicKey.setReadOnly();
    	file_privateKey.setReadOnly();
	}

    
    
    
    
	
    private void store(File file, Properties prop, String comment) throws IOException
    {
    	FileOutputStream fos = new FileOutputStream(file);
    	prop.store(fos,comment);
    	fos.close();
    }
} 
