package gus05.entity.gus.security.asymkeys.importpublickey.clipboard;


import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;
import gus05.framework.features.Transform;



public class ImportPublicKeyClipboard implements Entity, Give, Transform {


    public String getName()				{return "gus.security.asymkeys.importpublickey.clipboard";}
    public String getCreationDate()		{return "2008.06.13";}


    private Service clipboardProp;
    private Service propToPublicKey;

    public ImportPublicKeyClipboard() throws Exception
    {
    	clipboardProp = Outside.service(this,"gus.app.clipboard.prop");
    	propToPublicKey = Outside.service(this,"gus.security.asymkeys.proptopublickey");
    }


    public Object transform(Object obj) throws Exception
    {
    	File storeDir = (File) obj;
    	return importPublicKey(storeDir);
	}

    public void give(Object obj) throws Exception
    {
    	File storeDir = (File) obj;
    	importPublicKey(storeDir);
    }
    
    
    
    private String importPublicKey(File storeDir) throws Exception
    {
    	Properties prop = (Properties) clipboardProp.provide();
    	propToPublicKey.transform(prop);
    	
    	String owner = prop.getProperty(SECURITY.PUBLICKEY_OWNER);
    	File f = new File(storeDir,owner+"."+SECURITY.PUBLICKEY_FILEEXTENSION);
    	
    	store(f, prop, "public key specifications for "+owner);
    	f.setReadOnly();
    	return owner;
    }
    
    
    
    private void store(File file, Properties prop, String comment) throws IOException
    {
    	FileOutputStream fos = new FileOutputStream(file);
    	prop.store(fos,comment);
    	fos.close();
    }
	


}

