package gus05.entity.gus.security.asymkeys.verifykeys;


import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.Signature;

import gus05.framework.core.Entity;
import gus05.framework.features.Give;



public class VerifyKeys implements Entity, Give {

    
    public String getName() {return "gus.security.asymkeys.verifykeys";}
    public String getCreationDate() {return "2008.06.12";}
    
    
    
    private Signature si;
    
    
    public VerifyKeys() throws Exception
    {
    	si = Signature.getInstance(SECURITY.SECURITY_ALGO_DSA);
    }

    
    
    public void give(Object obj) throws Exception
	{
    	Object[] keys = (Object[]) obj;
    	if(keys.length!=2)  throw new Exception("wrong keys number: "+keys.length);
    	
    	PrivateKey privateKey = (PrivateKey) keys[0];
    	PublicKey publicKey = (PublicKey) keys[1];
    	byte[] data = randomData(30);
    	
    	boolean valid = verifyKeys(privateKey, publicKey, data);
    	if(!valid) throw new Exception("key verification failed");
	}
    
    
    
    
    private boolean verifyKeys(PrivateKey privateKey, PublicKey publicKey, byte[] input) throws Exception
    {
    	si.initSign(privateKey);
    	si.update(input);
        byte[] signData = si.sign();
        
        si.initVerify(publicKey);
        si.update(input);
        return si.verify(signData);
    }
    
    
    
    
    
    private byte[] randomData(int length)
    {
    	byte[] b = new byte[length];
    	for(int i=0;i<length;i++) b[i] = randomByte();
    	return b;
    }
    
    
    
    private byte randomByte()
	{
		int n = (int)(Math.random()*255);
		return (byte)n;
	}
} 
