/*
 * Created on 25 juin 2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package gus05.manager.gus.endorf.layer4.internals1;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketException;
import java.util.HashMap;
import java.util.Iterator;

import javax.net.ServerSocketFactory;

import gus05.framework.features.Filter;
import gus05.framework.features.Give;
import gus05.framework.features.Provide;
import gus05.framework.features.Retrieve;
import gus05.framework.features.Transform;
import gus05.framework.tools.DefaultSupport;
import gus05.manager.gus.endorf.layer4.system2.System2;



public class AppServerManager extends DefaultSupport implements Transform, Filter, Provide, Retrieve {

    private ServerSocketFactory factory;
    private HashMap map;
    private Integer lastPort;
    
    
    public HashMap getMap()
    {return map;}

    public AppServerManager()
    {
        map = new HashMap();
        factory = ServerSocketFactory.getDefault();
        
        System2.finalTasks.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){stopAllServers();}});
    }
    
    
    
    
    
    private Server server(Integer port)
    {
        if(!map.containsKey(port))createServer(port);
        return (Server)map.get(port);
    }
    
    private void createServer(Integer port)
    {
        map.put(port,new Server(port));
        lastPort = port;
        send(this,"createServer(Integer)");
    }
    
    
    

    public Object transform(Object obj) throws Exception
    {return server((Integer)obj);}
    

    public boolean filter(Object obj) throws Exception
    {return server((Integer)obj).isRunning();}
    

    public Object provide() throws Exception
    {return map;}

    
    public Object retrieve(String key) throws Exception
    {
        if(key.equals("lastPort")) return lastPort;
        if(key.equals("keys")) return new String[]{"lastPort"};
        throw new Exception("Unknown key: "+key);
    }
    
    
    
    private void stopAllServers()
    {
        Iterator it = map.keySet().iterator();
        while(it.hasNext())
        {
            Integer port = (Integer)it.next();
            Server server = (Server)map.get(port);
            server.stopServer();
        }
    }
    
    
    
    
    
    private class Server extends DefaultSupport implements Provide, Give, Retrieve, Runnable {

        
    	private Integer port;
    	private ServerSocket serverSocket;  
        private Socket lastSocket;
        private boolean running;
        
        
        public Server(Integer port)
        {
            this.port = port;
            running = false;
        }
     
        public boolean isRunning()
        {return running;}


        public Object provide() throws Exception
        {return lastSocket;}

        
        public void give(Object obj) throws Exception
        {
            String command = (String)obj;
            if(command.equals("start")) startServer();
            if(command.equals("stop")) stopServer();
        }
        
        
        public Object retrieve(String key) throws Exception
        {
            if(key.equals("port")) return port;
            if(key.equals("keys")) return new String[]{"port"};
            throw new Exception("Unknown key: "+key);
        }
        
        
        public void run()
        {
            serverStarted();
            while(!serverSocket.isClosed())
            waitingForNextConnection();
            running = false;
        }
        
        
        
        public void startServer()
        {
            try
            {
                if(running)return;
                running = true; 
                serverSocket = factory.createServerSocket(port.intValue());
                new Thread(this).start();
            }
            catch(Exception e)
            {serverFailed(e);}
        }
        
        public void stopServer()
        {
            try
            {
                if(!running) return;
                serverSocket.close();
            }
            catch(Exception e)
            {System2.handleError(this,"stopServer()",e);}
            serverStopped();
        }
        

        
        
        
        private void waitingForNextConnection()
        {
            try
            {
                lastSocket = serverSocket.accept();
                newSocket();
            }
            catch(SocketException se) {}
            catch(IOException e)
            {System2.handleError(this,"waitingForNextConnection()",e);}
        }
        
        
        
        private void serverStarted()
        {
            System2.printMessage(this,"serverStarted()","server started on port "+port);
            send(this,"serverStarted()");
        }
        
        private void serverStopped()
        {
            System2.printMessage(this,"serverStopped()","server stopped on port "+port);
            send(this,"serverStopped()");
        }
        
        private void serverFailed(Exception e)
        {
            System2.handleError(this,"serverFailed()",e);
            send(this,"serverFailed()");
        }
        
        private void newSocket()
        {
            System2.printMessage(this,"newSocket()","new socket accepted on port "+port+": "+lastSocket.getInetAddress().getHostAddress());
            send(this,"newSocket()");
        }

        
    }





    





    

}
